dpkg-maintscript-helper.sh 17 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583
  1. #!/bin/sh
  2. #
  3. # Copyright © 2007,2011-2013 Guillem Jover <guillem@debian.org>
  4. # Copyright © 2010 Raphaël Hertzog <hertzog@debian.org>
  5. # Copyright © 2008 Joey Hess <joeyh@debian.org>
  6. # Copyright © 2005 Scott James Remnant (original implementation on www.dpkg.org)
  7. #
  8. # This program is free software; you can redistribute it and/or modify
  9. # it under the terms of the GNU General Public License as published by
  10. # the Free Software Foundation; either version 2 of the License, or
  11. # (at your option) any later version.
  12. #
  13. # This program is distributed in the hope that it will be useful,
  14. # but WITHOUT ANY WARRANTY; without even the implied warranty of
  15. # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  16. # GNU General Public License for more details.
  17. #
  18. # You should have received a copy of the GNU General Public License
  19. # along with this program. If not, see <https://www.gnu.org/licenses/>.
  20. # The conffile related functions are inspired by
  21. # https://wiki.debian.org/DpkgConffileHandling
  22. # This script is documented in dpkg-maintscript-helper(1)
  23. ##
  24. ## Functions to remove an obsolete conffile during upgrade
  25. ##
  26. rm_conffile() {
  27. local CONFFILE="$1"
  28. local LASTVERSION="$2"
  29. local PACKAGE="$3"
  30. if [ "$LASTVERSION" = "--" ]; then
  31. LASTVERSION=""
  32. PACKAGE="$DPKG_MAINTSCRIPT_PACKAGE${DPKG_MAINTSCRIPT_ARCH:+:$DPKG_MAINTSCRIPT_ARCH}"
  33. fi
  34. if [ "$PACKAGE" = "--" -o -z "$PACKAGE" ]; then
  35. PACKAGE="$DPKG_MAINTSCRIPT_PACKAGE${DPKG_MAINTSCRIPT_ARCH:+:$DPKG_MAINTSCRIPT_ARCH}"
  36. fi
  37. # Skip remaining parameters up to --
  38. while [ "$1" != "--" -a $# -gt 0 ]; do shift; done
  39. [ $# -gt 0 ] || badusage "missing arguments after --"
  40. shift
  41. [ -n "$PACKAGE" ] || error "couldn't identify the package"
  42. [ -n "$1" ] || error "maintainer script parameters are missing"
  43. [ -n "$DPKG_MAINTSCRIPT_NAME" ] || \
  44. error "environment variable DPKG_MAINTSCRIPT_NAME is required"
  45. debug "Executing $0 rm_conffile in $DPKG_MAINTSCRIPT_NAME" \
  46. "of $DPKG_MAINTSCRIPT_PACKAGE"
  47. debug "CONFFILE=$CONFFILE PACKAGE=$PACKAGE" \
  48. "LASTVERSION=$LASTVERSION ACTION=$1 PARAM=$2"
  49. case "$DPKG_MAINTSCRIPT_NAME" in
  50. preinst)
  51. if [ "$1" = "install" -o "$1" = "upgrade" ] && [ -n "$2" ] &&
  52. dpkg --compare-versions "$2" le-nl "$LASTVERSION"; then
  53. prepare_rm_conffile "$CONFFILE" "$PACKAGE"
  54. fi
  55. ;;
  56. postinst)
  57. if [ "$1" = "configure" ] && [ -n "$2" ] &&
  58. dpkg --compare-versions "$2" le-nl "$LASTVERSION"; then
  59. finish_rm_conffile "$CONFFILE"
  60. fi
  61. ;;
  62. postrm)
  63. if [ "$1" = "purge" ]; then
  64. rm -f "$CONFFILE.dpkg-bak" "$CONFFILE.dpkg-remove" \
  65. "$CONFFILE.dpkg-backup"
  66. fi
  67. if [ "$1" = "abort-install" -o "$1" = "abort-upgrade" ] &&
  68. [ -n "$2" ] &&
  69. dpkg --compare-versions "$2" le-nl "$LASTVERSION"; then
  70. abort_rm_conffile "$CONFFILE" "$PACKAGE"
  71. fi
  72. ;;
  73. *)
  74. debug "$0 rm_conffile not required in $DPKG_MAINTSCRIPT_NAME"
  75. ;;
  76. esac
  77. }
  78. prepare_rm_conffile() {
  79. local CONFFILE="$1"
  80. local PACKAGE="$2"
  81. [ -e "$CONFFILE" ] || return 0
  82. ensure_package_owns_file "$PACKAGE" "$CONFFILE" || return 0
  83. local md5sum="$(md5sum $CONFFILE | sed -e 's/ .*//')"
  84. local old_md5sum="$(dpkg-query -W -f='${Conffiles}' $PACKAGE | \
  85. sed -n -e "\' $CONFFILE ' { s/ obsolete$//; s/.* //; p }")"
  86. if [ "$md5sum" != "$old_md5sum" ]; then
  87. echo "Obsolete conffile $CONFFILE has been modified by you."
  88. echo "Saving as $CONFFILE.dpkg-bak ..."
  89. mv -f "$CONFFILE" "$CONFFILE.dpkg-backup"
  90. else
  91. echo "Moving obsolete conffile $CONFFILE out of the way..."
  92. mv -f "$CONFFILE" "$CONFFILE.dpkg-remove"
  93. fi
  94. }
  95. finish_rm_conffile() {
  96. local CONFFILE="$1"
  97. if [ -e "$CONFFILE.dpkg-backup" ]; then
  98. mv -f "$CONFFILE.dpkg-backup" "$CONFFILE.dpkg-bak"
  99. fi
  100. if [ -e "$CONFFILE.dpkg-remove" ]; then
  101. echo "Removing obsolete conffile $CONFFILE ..."
  102. rm -f "$CONFFILE.dpkg-remove"
  103. fi
  104. }
  105. abort_rm_conffile() {
  106. local CONFFILE="$1"
  107. local PACKAGE="$2"
  108. ensure_package_owns_file "$PACKAGE" "$CONFFILE" || return 0
  109. if [ -e "$CONFFILE.dpkg-remove" ]; then
  110. echo "Reinstalling $CONFFILE that was moved away"
  111. mv "$CONFFILE.dpkg-remove" "$CONFFILE"
  112. fi
  113. if [ -e "$CONFFILE.dpkg-backup" ]; then
  114. echo "Reinstalling $CONFFILE that was backupped"
  115. mv "$CONFFILE.dpkg-backup" "$CONFFILE"
  116. fi
  117. }
  118. ##
  119. ## Functions to rename a conffile during upgrade
  120. ##
  121. mv_conffile() {
  122. local OLDCONFFILE="$1"
  123. local NEWCONFFILE="$2"
  124. local LASTVERSION="$3"
  125. local PACKAGE="$4"
  126. if [ "$LASTVERSION" = "--" ]; then
  127. LASTVERSION=""
  128. PACKAGE="$DPKG_MAINTSCRIPT_PACKAGE${DPKG_MAINTSCRIPT_ARCH:+:$DPKG_MAINTSCRIPT_ARCH}"
  129. fi
  130. if [ "$PACKAGE" = "--" -o -z "$PACKAGE" ]; then
  131. PACKAGE="$DPKG_MAINTSCRIPT_PACKAGE${DPKG_MAINTSCRIPT_ARCH:+:$DPKG_MAINTSCRIPT_ARCH}"
  132. fi
  133. # Skip remaining parameters up to --
  134. while [ "$1" != "--" -a $# -gt 0 ]; do shift; done
  135. [ $# -gt 0 ] || badusage "missing arguments after --"
  136. shift
  137. [ -n "$PACKAGE" ] || error "couldn't identify the package"
  138. [ -n "$1" ] || error "maintainer script parameters are missing"
  139. [ -n "$DPKG_MAINTSCRIPT_NAME" ] || \
  140. error "environment variable DPKG_MAINTSCRIPT_NAME is required"
  141. debug "Executing $0 mv_conffile in $DPKG_MAINTSCRIPT_NAME" \
  142. "of $DPKG_MAINTSCRIPT_PACKAGE"
  143. debug "CONFFILE=$OLDCONFFILE -> $NEWCONFFILE PACKAGE=$PACKAGE" \
  144. "LASTVERSION=$LASTVERSION ACTION=$1 PARAM=$2"
  145. case "$DPKG_MAINTSCRIPT_NAME" in
  146. preinst)
  147. if [ "$1" = "install" -o "$1" = "upgrade" ] && [ -n "$2" ] &&
  148. dpkg --compare-versions "$2" le-nl "$LASTVERSION"; then
  149. prepare_mv_conffile "$OLDCONFFILE" "$PACKAGE"
  150. fi
  151. ;;
  152. postinst)
  153. if [ "$1" = "configure" ] && [ -n "$2" ] &&
  154. dpkg --compare-versions "$2" le-nl "$LASTVERSION"; then
  155. finish_mv_conffile "$OLDCONFFILE" "$NEWCONFFILE" "$PACKAGE"
  156. fi
  157. ;;
  158. postrm)
  159. if [ "$1" = "abort-install" -o "$1" = "abort-upgrade" ] &&
  160. [ -n "$2" ] &&
  161. dpkg --compare-versions "$2" le-nl "$LASTVERSION"; then
  162. abort_mv_conffile "$OLDCONFFILE" "$PACKAGE"
  163. fi
  164. ;;
  165. *)
  166. debug "$0 mv_conffile not required in $DPKG_MAINTSCRIPT_NAME"
  167. ;;
  168. esac
  169. }
  170. prepare_mv_conffile() {
  171. local CONFFILE="$1"
  172. local PACKAGE="$2"
  173. [ -e "$CONFFILE" ] || return 0
  174. ensure_package_owns_file "$PACKAGE" "$CONFFILE" || return 0
  175. local md5sum="$(md5sum $CONFFILE | sed -e 's/ .*//')"
  176. local old_md5sum="$(dpkg-query -W -f='${Conffiles}' $PACKAGE | \
  177. sed -n -e "\' $CONFFILE ' { s/ obsolete$//; s/.* //; p }")"
  178. if [ "$md5sum" = "$old_md5sum" ]; then
  179. mv -f "$CONFFILE" "$CONFFILE.dpkg-remove"
  180. fi
  181. }
  182. finish_mv_conffile() {
  183. local OLDCONFFILE="$1"
  184. local NEWCONFFILE="$2"
  185. local PACKAGE="$3"
  186. rm -f $OLDCONFFILE.dpkg-remove
  187. [ -e "$OLDCONFFILE" ] || return 0
  188. ensure_package_owns_file "$PACKAGE" "$OLDCONFFILE" || return 0
  189. echo "Preserving user changes to $NEWCONFFILE (renamed from $OLDCONFFILE)..."
  190. mv -f "$NEWCONFFILE" "$NEWCONFFILE.dpkg-new"
  191. mv -f "$OLDCONFFILE" "$NEWCONFFILE"
  192. }
  193. abort_mv_conffile() {
  194. local CONFFILE="$1"
  195. local PACKAGE="$2"
  196. ensure_package_owns_file "$PACKAGE" "$CONFFILE" || return 0
  197. if [ -e "$CONFFILE.dpkg-remove" ]; then
  198. echo "Reinstalling $CONFFILE that was moved away"
  199. mv "$CONFFILE.dpkg-remove" "$CONFFILE"
  200. fi
  201. }
  202. ##
  203. ## Functions to replace a symlink with a directory
  204. ##
  205. symlink_to_dir() {
  206. local SYMLINK="$1"
  207. local SYMLINK_TARGET="$2"
  208. local LASTVERSION="$3"
  209. local PACKAGE="$4"
  210. if [ "$LASTVERSION" = "--" ]; then
  211. LASTVERSION=""
  212. PACKAGE="$DPKG_MAINTSCRIPT_PACKAGE${DPKG_MAINTSCRIPT_ARCH:+:$DPKG_MAINTSCRIPT_ARCH}"
  213. fi
  214. if [ "$PACKAGE" = "--" -o -z "$PACKAGE" ]; then
  215. PACKAGE="$DPKG_MAINTSCRIPT_PACKAGE${DPKG_MAINTSCRIPT_ARCH:+:$DPKG_MAINTSCRIPT_ARCH}"
  216. fi
  217. # Skip remaining parameters up to --
  218. while [ "$1" != "--" -a $# -gt 0 ]; do shift; done
  219. [ $# -gt 0 ] || badusage "missing arguments after --"
  220. shift
  221. [ -n "$DPKG_MAINTSCRIPT_NAME" ] || \
  222. error "environment variable DPKG_MAINTSCRIPT_NAME is required"
  223. [ -n "$PACKAGE" ] || error "cannot identify the package"
  224. [ -n "$SYMLINK" ] || error "symlink parameter is missing"
  225. [ -n "$SYMLINK_TARGET" ] || error "original symlink target is missing"
  226. [ -n "$LASTVERSION" ] || error "last version is missing"
  227. [ -n "$1" ] || error "maintainer script parameters are missing"
  228. debug "Executing $0 symlink_to_dir in $DPKG_MAINTSCRIPT_NAME" \
  229. "of $DPKG_MAINTSCRIPT_PACKAGE"
  230. debug "SYMLINK=$SYMLINK -> $SYMLINK_TARGET PACKAGE=$PACKAGE" \
  231. "LASTVERSION=$LASTVERSION ACTION=$1 PARAM=$2"
  232. case "$DPKG_MAINTSCRIPT_NAME" in
  233. preinst)
  234. if [ "$1" = "install" -o "$1" = "upgrade" ] &&
  235. [ -n "$2" ] && [ -h "$SYMLINK" ] &&
  236. [ "$(readlink -f $SYMLINK)" = "$SYMLINK_TARGET" ] &&
  237. dpkg --compare-versions "$2" le-nl "$LASTVERSION"; then
  238. mv -f "$SYMLINK" "${SYMLINK}.dpkg-backup"
  239. fi
  240. ;;
  241. postinst)
  242. # We cannot bail depending on the version, as here we only
  243. # know what was the last configured version, and we might
  244. # have been unpacked, then upgraded with an unpack and thus
  245. # never been configured before.
  246. if [ "$1" = "configure" ] && [ -h "${SYMLINK}.dpkg-backup" ] &&
  247. [ "$(readlink -f ${SYMLINK}.dpkg-backup)" = "$SYMLINK_TARGET" ]
  248. then
  249. rm -f "${SYMLINK}.dpkg-backup"
  250. fi
  251. ;;
  252. postrm)
  253. if [ "$1" = "purge" ] && [ -h "${SYMLINK}.dpkg-backup" ]; then
  254. rm -f "${SYMLINK}.dpkg-backup"
  255. fi
  256. if [ "$1" = "abort-install" -o "$1" = "abort-upgrade" ] &&
  257. [ -n "$2" ] &&
  258. [ ! -e "$SYMLINK" ] && [ -h "${SYMLINK}.dpkg-backup" ] &&
  259. [ "$(readlink -f ${SYMLINK}.dpkg-backup)" = "$SYMLINK_TARGET" ] &&
  260. dpkg --compare-versions "$2" le-nl "$LASTVERSION"; then
  261. echo "Restoring backup of $SYMLINK ..."
  262. mv "${SYMLINK}.dpkg-backup" "$SYMLINK"
  263. fi
  264. ;;
  265. *)
  266. debug "$0 symlink_to_dir not required in $DPKG_MAINTSCRIPT_NAME"
  267. ;;
  268. esac
  269. }
  270. ##
  271. ## Functions to replace a directory with a symlink
  272. ##
  273. dir_to_symlink() {
  274. local PATHNAME="$1"
  275. local SYMLINK_TARGET="$2"
  276. local LASTVERSION="$3"
  277. local PACKAGE="$4"
  278. if [ "$LASTVERSION" = "--" ]; then
  279. LASTVERSION=""
  280. PACKAGE="$DPKG_MAINTSCRIPT_PACKAGE${DPKG_MAINTSCRIPT_ARCH:+:$DPKG_MAINTSCRIPT_ARCH}"
  281. fi
  282. if [ "$PACKAGE" = "--" -o -z "$PACKAGE" ]; then
  283. PACKAGE="$DPKG_MAINTSCRIPT_PACKAGE${DPKG_MAINTSCRIPT_ARCH:+:$DPKG_MAINTSCRIPT_ARCH}"
  284. fi
  285. # Skip remaining parameters up to --
  286. while [ "$1" != "--" -a $# -gt 0 ]; do shift; done
  287. [ $# -gt 0 ] || badusage "missing arguments after --"
  288. shift
  289. [ -n "$DPKG_MAINTSCRIPT_NAME" ] || \
  290. error "environment variable DPKG_MAINTSCRIPT_NAME is required"
  291. [ -n "$PACKAGE" ] || error "cannot identify the package"
  292. [ -n "$PATHNAME" ] || error "directory parameter is missing"
  293. [ -n "$SYMLINK_TARGET" ] || error "new symlink target is missing"
  294. [ -n "$LASTVERSION" ] || error "last version is missing"
  295. [ -n "$1" ] || error "maintainer script parameters are missing"
  296. debug "Executing $0 dir_to_symlink in $DPKG_MAINTSCRIPT_NAME" \
  297. "of $DPKG_MAINTSCRIPT_PACKAGE"
  298. debug "PATHNAME=$PATHNAME SYMLINK_TARGET=$SYMLINK_TARGET" \
  299. "PACKAGE=$PACKAGE LASTVERSION=$LASTVERSION ACTION=$1 PARAM=$2"
  300. case "$DPKG_MAINTSCRIPT_NAME" in
  301. preinst)
  302. if [ "$1" = "install" -o "$1" = "upgrade" ] &&
  303. [ -n "$2" ] &&
  304. [ ! -h "$PATHNAME" ] && [ -d "$PATHNAME" ] &&
  305. dpkg --compare-versions "$2" le-nl "$LASTVERSION"; then
  306. prepare_dir_to_symlink "$PACKAGE" "$PATHNAME"
  307. fi
  308. ;;
  309. postinst)
  310. # We cannot bail depending on the version, as here we only
  311. # know what was the last configured version, and we might
  312. # have been unpacked, then upgraded with an unpack and thus
  313. # never been configured before.
  314. if [ "$1" = "configure" ] &&
  315. [ -d "${PATHNAME}.dpkg-backup" ] &&
  316. [ ! -h "$PATHNAME" ] && [ -d "$PATHNAME" ] &&
  317. [ -f "$PATHNAME/.dpkg-staging-dir" ]; then
  318. finish_dir_to_symlink "$PATHNAME" "$SYMLINK_TARGET"
  319. fi
  320. ;;
  321. postrm)
  322. if [ "$1" = "purge" ] && [ -d "${PATHNAME}.dpkg-backup" ]; then
  323. rm -rf "${PATHNAME}.dpkg-backup"
  324. fi
  325. if [ "$1" = "abort-install" -o "$1" = "abort-upgrade" ] &&
  326. [ -n "$2" ] &&
  327. [ -d "${PATHNAME}.dpkg-backup" ] &&
  328. [ \( ! -h "$PATHNAME" -a -d "$PATHNAME" -a \
  329. -f "$PATHNAME/.dpkg-staging-dir" \) -o \
  330. \( -h "$PATHNAME" -a \
  331. "$(readlink -f $PATHNAME)" = "$SYMLINK_TARGET" \) ] &&
  332. dpkg --compare-versions "$2" le-nl "$LASTVERSION"; then
  333. abort_dir_to_symlink "$PATHNAME"
  334. fi
  335. ;;
  336. *)
  337. debug "$0 dir_to_symlink not required in $DPKG_MAINTSCRIPT_NAME"
  338. ;;
  339. esac
  340. }
  341. prepare_dir_to_symlink()
  342. {
  343. local PACKAGE="$1"
  344. local PATHNAME="$2"
  345. # If there are conffiles we should not perform the switch.
  346. if dpkg-query -W -f='${Conffiles}' "$PACKAGE" | \
  347. grep -q "$PATHNAME/."; then
  348. error "directory '$PATHNAME' contains conffiles," \
  349. "cannot switch to symlink"
  350. fi
  351. # If there are locally created files or files owned by another package
  352. # we should not perform the switch.
  353. find "$PATHNAME" -print0 | xargs -0 -n1 sh -c '
  354. package="$1"
  355. file="$2"
  356. if ! dpkg-query -L "$package" | grep -q -x "$file"; then
  357. return 1
  358. fi
  359. return 0
  360. ' check-files-ownership "$PACKAGE" || \
  361. error "directory '$PATHNAME' contains files not owned by" \
  362. "package $PACKAGE, cannot switch to symlink"
  363. # At this point, we know that the directory either contains no files,
  364. # or only non-conffiles owned by the package.
  365. #
  366. # To do the switch we cannot simply replace it with the final symlink
  367. # just yet, because dpkg needs to remove any file present in the old
  368. # package that have disappeared in the new one, and we do not want to
  369. # lose files resolving to the same pathname in the symlink target.
  370. #
  371. # We cannot replace the directory with a staging symlink either,
  372. # because dpkg will update symlinks to their new target.
  373. #
  374. # So we need to create a staging directory, to avoid removing files
  375. # from other packages, and to trap any new files in the directory
  376. # to move them to their correct place later on.
  377. mv -f "$PATHNAME" "${PATHNAME}.dpkg-backup"
  378. mkdir "$PATHNAME"
  379. # Mark it as a staging directory, so that we can track things.
  380. touch "$PATHNAME/.dpkg-staging-dir"
  381. }
  382. finish_dir_to_symlink()
  383. {
  384. local PATHNAME="$1"
  385. local SYMLINK_TARGET="$2"
  386. # Move the contents of the staging directory to the symlink target,
  387. # as those are all new files installed between this package being
  388. # unpacked and configured.
  389. rm "$PATHNAME/.dpkg-staging-dir"
  390. find "$PATHNAME" -mindepth 1 -print0 | \
  391. xargs -0 -i% mv -f "%" "$SYMLINK_TARGET/"
  392. # Remove the staging directory.
  393. rmdir "$PATHNAME"
  394. # Do the actual switch.
  395. ln -s "$SYMLINK_TARGET" "$PATHNAME"
  396. # We are left behind the old files owned by this package in the backup
  397. # directory, just remove it.
  398. rm -rf "${PATHNAME}.dpkg-backup"
  399. }
  400. abort_dir_to_symlink()
  401. {
  402. local PATHNAME="$1"
  403. echo "Restoring backup of $PATHNAME ..."
  404. if [ -h "$PATHNAME" ]; then
  405. rm -f "$PATHNAME"
  406. else
  407. # The staging directory must be empty, as no other package
  408. # should have been unpacked inbetween.
  409. rm -f "$PATHNAME/.dpkg-staging-dir"
  410. rmdir "$PATHNAME"
  411. fi
  412. mv "${PATHNAME}.dpkg-backup" "$PATHNAME"
  413. }
  414. # Common functions
  415. ensure_package_owns_file() {
  416. local PACKAGE="$1"
  417. local FILE="$2"
  418. if ! dpkg-query -L "$PACKAGE" | grep -q -x "$FILE"; then
  419. debug "File '$FILE' not owned by package " \
  420. "'$PACKAGE', skipping $command"
  421. return 1
  422. fi
  423. return 0
  424. }
  425. debug() {
  426. if [ -n "$DPKG_DEBUG" ]; then
  427. echo "DEBUG: $PROGNAME: $*" >&2
  428. fi
  429. }
  430. error() {
  431. echo "$PROGNAME: error: $*" >&2
  432. exit 1
  433. }
  434. warning() {
  435. echo "$PROGNAME: warning: $*" >&2
  436. }
  437. usage() {
  438. cat <<END
  439. Usage: $PROGNAME <command> <parameter>... -- <maintainer-script-parameter>...
  440. Commands:
  441. supports <command>
  442. Returns 0 (success) if the given command is supported, 1 otherwise.
  443. rm_conffile <conffile> [<last-version> [<package>]]
  444. Remove obsolete conffile. Must be called in preinst, postinst and
  445. postrm.
  446. mv_conffile <old-conf> <new-conf> [<last-version> [<package>]]
  447. Rename a conffile. Must be called in preinst, postinst and postrm.
  448. symlink_to_dir <pathname> <old-symlink-target> [<last-version> [<package>]]
  449. Replace a symlink with a directory. Must be called in preinst,
  450. postinst and postrm.
  451. dir_to_symlink <pathname> <new-symlink-target> [<last-version> [<package>]]
  452. Replace a directory with a symlink. Must be called in preinst,
  453. postinst and postrm.
  454. help
  455. Display this usage information.
  456. END
  457. }
  458. badusage() {
  459. echo "$PROGNAME: error: $1" >&2
  460. echo >&2
  461. echo "Use '$PROGNAME help' for program usage information." >&2
  462. exit 1
  463. }
  464. # Main code
  465. set -e
  466. PROGNAME=$(basename $0)
  467. version="unknown"
  468. command="$1"
  469. [ $# -gt 0 ] || badusage "missing command"
  470. shift
  471. case "$command" in
  472. supports)
  473. case "$1" in
  474. rm_conffile|mv_conffile|symlink_to_dir|dir_to_symlink)
  475. code=0
  476. ;;
  477. *)
  478. code=1
  479. ;;
  480. esac
  481. if [ -z "$DPKG_MAINTSCRIPT_NAME" ]; then
  482. warning "environment variable DPKG_MAINTSCRIPT_NAME missing"
  483. code=1
  484. fi
  485. if [ -z "$DPKG_MAINTSCRIPT_PACKAGE" ]; then
  486. warning "environment variable DPKG_MAINTSCRIPT_PACKAGE missing"
  487. code=1
  488. fi
  489. exit $code
  490. ;;
  491. rm_conffile)
  492. rm_conffile "$@"
  493. ;;
  494. mv_conffile)
  495. mv_conffile "$@"
  496. ;;
  497. symlink_to_dir)
  498. symlink_to_dir "$@"
  499. ;;
  500. dir_to_symlink)
  501. dir_to_symlink "$@"
  502. ;;
  503. --help|help|-?)
  504. usage
  505. ;;
  506. --version)
  507. cat <<-END
  508. Debian $PROGNAME version $version.
  509. This is free software; see the GNU General Public License version 2 or
  510. later for copying conditions. There is NO warranty.
  511. END
  512. ;;
  513. *)
  514. badusage "command $command is unknown
  515. Hint: upgrading dpkg to a newer version might help."
  516. esac
  517. exit 0